------------------------------------------------------------------------------------------------------------------------------------------------------
--                                                          Adicionais Laboratrio - Joins                                                          --
--                                               Treinamento para certificao Fundamentals SQL Oracle                                              --
--                                           Pedro F. Carvalho - DBA / Analista de Sistemas / Desenvolvedor                                         --
--                                         Site : www.pedrofcarvalho.com.br   E-mail : contato@pedrofcarvalho.com.br                                --
------------------------------------------------------------------------------------------------------------------------------------------------------

/*Exerccio 01
Escrever uma consulta que produza o endereo de todos os departamentos, usando tabelas locations e countries.
Mostre o location id, streed adress, city, status ou provience e country em sua saida.*/

select location_id, street_address, city, state_province, country_name
from locations, countries
where locations.country_id = countries.country_id;
      

/*Exerccio 02
Fazer um relatrio de todos os empregados que mostre o ultimo nome, o numero do departamento o nome do departamento
para todos os empregados*/

select e.last_name, e.department_id, d.department_name
from employees e, departments d
where e.department_id = d.department_id;


/*Exerccio 03
Fazer um relatrio de todos os empregados de toronto.  Mostre o nome, o trabalho, o numero de departamento e o nome do 
departamento*/

select e.last_name, e.job_id, e.department_id, d.department_name
from employees e, departments d, locations l
where e.department_id = d.department_id
and  d.location_id = l.location_id
and LOWER(l.city) = 'toronto';


/*Exerccio 04
Criar um relatrio que mostre o ultimo nome e o numero do empregado com o ultimo nome de seu manager e seu numero.
Coloque os cabealhos Employee, Emp#, Manager, e Mgr# respectivamente. */


select w.last_name "Employee", w.employee_id "EMP#",
       m.last_name "Manager", m.employee_id "MGR#"
from employees w, employees m
where w.manager_id = m.employee_id;


/*Exerccio 05
Modificar o relatrio acima incluindo o King(ele no possui manager).
Ordene os resultados pelo numero do empregado*/

select w.last_name "Employee", w.employee_id "EMP#",
       m.last_name "Manager", m.employee_id "MGR#"
from employees w, employees m
where w.manager_id = m.employee_id(+)
order by 2;


/*Exerccio 06
Crie um relatrio que mostre o ultimo nome, o numero do departamento para todos os empregados que trabalha no mesmo departamento*/

select e1.department_id department, e1.last_name employee, e2.last_name colleague
from employees e1, employees e2
where e1.department_id = e2.DEPARTMENT_ID
and e1.employee_id <> e2.employee_id
order by e1.department_id, e1.last_name, e2.last_name;


/*Exerccio 07
Crie um relatrio que mostre os jobs grades e salarios, nomes, trabalho, nome do departamento, salario, e a grade para todos
empregados
*/

desc job_grades

select * from job_grades;

SELECT e.last_name, e.job_id, d.department_name, e.salary, j.grade_level
FROM employees e, departments d, job_grades j
WHERE e.department_id = d.department_id
AND e.salary BETWEEN j.lowest_sal AND j.highest_sal; -- no equijoins


/*Exerccio 08
Criar um relatrio que detrmina o nome dos empregados aps o cadastro de Davies.  Mostre o nome a data para todos empregados.
*/

select e.last_name, e.hire_date
from employees e, employees davies
where davies.last_name = 'Davies'
and davies.hire_date < e.hire_date;


/*Exerccio 09
Criar um relatrio que busca os nomes e data de cadastro para todos empregados que foram cadastrados antes de seus managers
Os cabealhos devero ser Employee, Emp Hired, Manager, e Mgr Hired
*/

select w.last_name Employee, w.hire_date Emp, m.last_name Manager, m.hire_date Hired
from employees w, employees m
where w.manager_id = m.employee_id
and w.hire_date < m.hire_date;


/*Exerccio 10
Crie um relatrio que mostre o nome dos empregados, o nome de seu departamento, o nome deseu job, o nome de sua location e seu countries
*/

select e.last_name, d.department_name, j.job_title, l.CITY, c.COUNTRY_NAME 
from employees e, departments d, jobs j, locations l, countries c
where e.department_id = d.department_id
and l.COUNTRY_ID = c.COUNTRY_ID
and e.job_id = j.job_id
and d.location_id = l.location_id;


-- Passos de estudos
-- 1 - Assistir esta video aula 1x
-- 2 - Assistir a video aula agora fazendo os scritps 1x
-- 5 - Realizar o simulado online
       
-- Abraos e bons estudos !
       






